| The Gaudi Framework v32r1 (f65d50dc)

Protected Member Functions | Static Protected Member Functions | List of all members
MemoryAuditor Class Reference

Monitors the memory use of each algorithm. More...

`#include <src/MemoryAuditor.h>`

Inheritance diagram for MemoryAuditor:
[legend]
Collaboration diagram for MemoryAuditor:
[legend]

## Protected Member Functions
void | i_before (CustomEventTypeRef evt, const std::string &caller) override
| Default (catch-all) "before" Auditor hook. More...
void | i_after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc) override
| Default (catch-all) "after" Auditor hook. More...
virtual void | i_printinfo (const std::string &msg, CustomEventTypeRef evt, const std::string &caller)
| Report the memory usage. More...
Protected Member Functions inherited from CommonAuditor
bool | i_auditEventType (const std::string &evt)
| Check if we are requested to audit the passed event type. More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Static Protected Member Functions
static bool | getProcInfo (procInfo &info)
| Get the process informations. More...

## Additional Inherited Members
Public Types inherited from Auditor
using | Factory = Gaudi::PluginService::Factory< IAuditor *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IAuditor, IProperty > >
using | base_class = CommonMessaging
Public Member Functions inherited from CommonAuditor
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| Auditor (const Auditor &a)=delete
| Constructor. More...
void | before (StandardEventType evt, const std::string &caller) override
void | before (StandardEventType evt, INamedInterface *caller) override
void | before (CustomEventTypeRef evt, const std::string &caller) override
void | before (CustomEventTypeRef evt, INamedInterface *caller) override
void | after (StandardEventType evt, const std::string &caller, const StatusCode &sc) override
void | after (StandardEventType evt, INamedInterface *caller, const StatusCode &sc) override
void | after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc) override
void | after (CustomEventTypeRef evt, INamedInterface *caller, const StatusCode &sc) override
Public Member Functions inherited from Auditor
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| Auditor (const Auditor &a)=delete
Auditor & | operator= (const Auditor &rhs)=delete
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysFinalize () override
| Finalization method invoked by the framework. More...
void | before (StandardEventType, INamedInterface *) override
| The following methods are meant to be implemented by the child class... More...
void | before (StandardEventType, const std::string &) override
void | before (CustomEventTypeRef, INamedInterface *) override
void | before (CustomEventTypeRef, const std::string &) override
void | after (StandardEventType, INamedInterface *, const StatusCode &) override
void | after (StandardEventType, const std::string &, const StatusCode &) override
void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &) override
void | after (CustomEventTypeRef, const std::string &, const StatusCode &) override
void | beforeInitialize (INamedInterface *) override
void | afterInitialize (INamedInterface *) override
void | beforeReinitialize (INamedInterface *) override
void | afterReinitialize (INamedInterface *) override
void | beforeExecute (INamedInterface *) override
void | afterExecute (INamedInterface *, const StatusCode &) override
void | beforeFinalize (INamedInterface *) override
void | afterFinalize (INamedInterface *) override
void | beforeBeginRun (INamedInterface *) override
void | afterBeginRun (INamedInterface *) override
void | beforeEndRun (INamedInterface *) override
void | afterEndRun (INamedInterface *) override
virtual StatusCode | initialize ()
virtual StatusCode | finalize ()
const std::string & | name () const override
bool | isEnabled () const override
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
template<class T >
StatusCode | service (const std::string &name, T *&svc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T = IService>
SmartIF< T > | service (const std::string &name, bool createIf=false) const
StatusCode | setProperties ()
| Set the auditor's properties. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Detailed Description

Monitors the memory use of each algorithm.

Author
  M. Shapiro, LBNL
  Marco Clemencic

Definition at line 11 of file MemoryAuditor.h.

## Member Function Documentation

## ◆ getProcInfo()

static bool MemoryAuditor::getProcInfo | ( | procInfo & | info | ) |
| inline static protected

Get the process informations.

Returns true if it was possible to retrieve the informations.

Definition at line 27 of file MemoryAuditor.h.

27 { return ProcStats::instance()->fetch( info ); }
ProcStats::instance
static ProcStats * instance()
Definition: ProcStats.cpp:239
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
ProcStats::fetch
bool fetch(procInfo &fill_me)
Definition: ProcStats.cpp:262

## ◆ i_after()

void MemoryAuditor::i_after | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller,
|  | const StatusCode & | sc
| ) |  |
| override protected virtual

Default (catch-all) "after" Auditor hook.

Implements CommonAuditor.

Definition at line 19 of file MemoryAuditor.cpp.

19 {
20 i_printinfo( "Memory usage has changed after", evt, caller );
21 }
MemoryAuditor::i_printinfo
virtual void i_printinfo(const std::string &msg, CustomEventTypeRef evt, const std::string &caller)
Report the memory usage.
Definition: MemoryAuditor.cpp:23
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ i_before()

void MemoryAuditor::i_before | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| override protected virtual

Default (catch-all) "before" Auditor hook.

Implements CommonAuditor.

Reimplemented in MemStatAuditor.

Definition at line 15 of file MemoryAuditor.cpp.

15 {
16 i_printinfo( "Memory usage before", evt, caller );
17 }
MemoryAuditor::i_printinfo
virtual void i_printinfo(const std::string &msg, CustomEventTypeRef evt, const std::string &caller)
Report the memory usage.
Definition: MemoryAuditor.cpp:23
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ i_printinfo()

void MemoryAuditor::i_printinfo | ( | const std::string & | msg,
|  | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| protected virtual

Report the memory usage.

Reimplemented in MemStatAuditor.

Definition at line 23 of file MemoryAuditor.cpp.

23 {
24 procInfo pInfo;
25 // The fetch method returns true if memory usage has changed...
26 if ( getProcInfo( pInfo ) ) {
27 info() << msg << " " << caller << " " << evt << " virtual size = " << pInfo.vsize << " MB"
28 << " resident set size = " << pInfo.rss << " MB" << endmsg;
29 }
30 }
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
procInfo::rss
double rss
Definition: ProcStats.h:38
MemoryAuditor::getProcInfo
static bool getProcInfo(procInfo &info)
Get the process informations.
Definition: MemoryAuditor.h:27
CommonMessagingBase::msg
MsgStream & msg() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:113
procInfo::vsize
double vsize
Definition: ProcStats.h:37
procInfo
Definition: ProcStats.h:17
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
IOTest.evt
evt
Definition: IOTest.py:94

The documentation for this class was generated from the following files:

- GaudiAud/src/MemoryAuditor.h
- GaudiAud/src/MemoryAuditor.cpp